import * as React from 'react';
import { Route, Switch } from 'react-router-dom';

import AccountLayout from './layout/AccountLayout';
import ProbeDetailLayout from './layout/ProbeDetailLayout';
import SensorDetailLayout from './layout/SensorDetailLayout';
import TargetDetailLayout from './layout/TargetDetailLayout';
import AppLayout from './layout/AppLayout';
import ErrorLayout from './layout/ErrorLayout';



import TempLayout from './layout/TempLayout';

export interface Props {
}
export interface State {
}

class App extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
  }

  public render(): JSX.Element {
    return (
      <Switch>
        <Route path='/error' component={ErrorLayout}/>
        <Route path='/account' component={AccountLayout}/>
        <Route path='/probe' component={ProbeDetailLayout}/>
        <Route path='/sensor' component={SensorDetailLayout}/>
        <Route path='/target' component={TargetDetailLayout}/>
        <Route path='/' component={AppLayout}/>
      </Switch>
    );
  }
}

export default App;

