import inject from '../context/decorator/inject';
import WebSocketRPC from '../websocket/WebSocketRPC';

abstract class Service {
  @inject()
  private webSocketRPC: WebSocketRPC;
  private name: string;
  protected constructor(name: string) {
    this.name = name;

  }

  protected send<T>(methodName: string, ...params: any[]): Promise<T> {
    return this.webSocketRPC.Call(methodName, params)
      .then(body => {
        const o: T = JSON.parse(body);
        return o;
      })
      .catch(e => {
        throw e;
      });
  }
}

export default Service;
