import * as METADATA from '../constants';

export interface Config {
  qualifier?: string;
  required?: boolean;
}


const inject = (config?: Config) => {
  return (target: Object, propertyKey: string | symbol, parameterIndex?: number): void => {
    if (typeof parameterIndex === 'number') {
      // tagParameter(target, targetKey, index, metadata);
    } else {
      let meta: Map<string | symbol, Config>;
      if (Reflect.hasOwnMetadata(METADATA.INJECT_TAG, target)) {
        meta = Reflect.getMetadata(METADATA.INJECT_TAG, target);
      } else {
        meta = new Map();
        Reflect.defineMetadata(METADATA.INJECT_TAG, meta, target);
      }
      if (meta.has(propertyKey)) {
        throw new Error('Cannot apply @injectable decorator multiple times.');
      }
      meta.set(propertyKey, config);
    }
  };
};

export default inject;
