import * as React from 'react';
import {
  Button,
  Modal,
  Checkbox,
  Header,
  Container,
} from 'semantic-ui-react';
import { DiscoveryProbe } from './DiscoveryProbe';
import { DiscoveryTable } from './DiscoveryTable';

export interface StateProps {
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  startPopup:boolean;
  probeTemp: any;
}

const probeTemp:Object = {
  'id': '11',
  'metaProbeStatus': {
    'name': 'STARTED',
  },
  'domain': {
    'name': 'overFlow\'s domain111',
  },
  'host': {
    'ip': '192.168.1.103',
    'mac': '44:8a:5b:44:8c:e8',
    'os': 'Ubuntu 17.04',
    'name': '?????',
  },
  'createAt': '2017-07-12',
  'probeKey': 'AGBLKDFJ2452ASDGFL2KWJLKSDJ',
  'description': 'description1111111111',
  'lastPollingAt': '2017-07-12 14:20',
  'nextPollingAt': '2017-07-12 14:30',
};

export class Discovery extends React.Component<Props, State> {

  private submitData: any;

  public constructor(props: Props, context: State) {
    super(props, context);
    this.handleProbeChange.bind(this);
    this.state = {
      startPopup:false,
      probeTemp:null,
    };
  }

  public componentWillMount():void {
    this.setState({probeTemp:probeTemp});
  }

  public handleProbeChange(obj: Object): void {
    console.log(obj);
    this.setState({ startPopup:true });
    this.submitData = obj;
  }

  public handleSubmit(): void {
    console.log(this.submitData);
  }

  public handleCancel= () => this.setState({ startPopup: false });

  public handlePopupClose = () => this.setState({ startPopup: false });

  public render(): JSX.Element  {
    return (
      <Container fluid>
        <Header as='h3' dividing> Discovery Details</Header>
        {/*<DiscoveryProbe probe={this.state.probeTemp}/>*/}
        <br />
        <DiscoveryTable onProbeChange={this.handleProbeChange.bind(this)} />

        <Modal size='small' open={this.state.startPopup} onClose={this.handlePopupClose}>
          <Modal.Header>Discovery.</Modal.Header>
          <Modal.Content >
            <Checkbox label='IP' />
          </Modal.Content>
          <Modal.Actions>
            <Button onClick={this.handleSubmit.bind(this)} basic color='blue'  >              Submit      </Button>
            <Button onClick={this.handleCancel}>              Cancel      </Button>
          </Modal.Actions>
        </Modal>

      </Container>

    );
  }
}
