import Action from '@overflow/commons/redux/Action';
import MetaCrawler from '../../api/model//MetaCrawler';
import Target from '@overflow/target/api/model/Target';

import CrawlerReadAllByTargetPayload from '../payload/CrawlerReadAllByTargetPayload';

// Action Type
export type REQUEST = '@overflow/meta_crawler/crawler_read_all_by_target/REQUEST';
export type REQUEST_SUCCESS = '@overflow/meta_crawler/crawler_read_all_by_target/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/meta_crawler/crawler_read_all_by_target/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/meta_crawler/crawler_read_all_by_target/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/meta_crawler/crawler_read_all_by_target/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/meta_crawler/crawler_read_all_by_target/REQUEST_FAILURE';

// Action Creater
export type request = (target: Target) => Action<CrawlerReadAllByTargetPayload>;
export type requestSuccess = (metaCrawlerList: MetaCrawler[]) => Action<MetaCrawler[]>;
export type requestFailure = (error: Error) => Action;



export const request: request = (target: Target): Action<CrawlerReadAllByTargetPayload> => {
  return {
    type: REQUEST,
    payload: {
      target: target,
    },
  };
};

export const requestSuccess: requestSuccess = (metaCrawlerList: MetaCrawler[]): Action<MetaCrawler[]> => {
  return {
    type: REQUEST_SUCCESS,
    payload: metaCrawlerList,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
