import Action from '@overflow/commons/redux/Action';
import MetaSensorItem from '../../api/model//MetaSensorItem';


import SensorItemReadAllPayload from '../payload/SensorItemReadAllPayload';

// Action Type
export type REQUEST = '@overflow/meta_sensor_item/sensor_item_read_all/REQUEST';
export type REQUEST_SUCCESS = '@overflow/meta_sensor_item/sensor_item_read_all/REQUEST_SUCCESS';
export type REQUEST_FAILURE = '@overflow/meta_sensor_item/sensor_item_read_all/REQUEST_FAILURE';

export const REQUEST: REQUEST = '@overflow/meta_sensor_item/sensor_item_read_all/REQUEST';
export const REQUEST_SUCCESS: REQUEST_SUCCESS = '@overflow/meta_sensor_item/sensor_item_read_all/REQUEST_SUCCESS';
export const REQUEST_FAILURE: REQUEST_FAILURE = '@overflow/meta_sensor_item/sensor_item_read_all/REQUEST_FAILURE';

// Action Creater
export type request = () => Action<SensorItemReadAllPayload>;
export type requestSuccess = (metaSensorItemList: MetaSensorItem[]) => Action<MetaSensorItem[]>;
export type requestFailure = (error: Error) => Action;



export const request: request = (): Action<SensorItemReadAllPayload> => {
  return {
    type: REQUEST,
    payload: {

    },
  };
};

export const requestSuccess: requestSuccess = (metaSensorItemList: MetaSensorItem[]): Action<MetaSensorItem[]> => {
  return {
    type: REQUEST_SUCCESS,
    payload: metaSensorItemList,
  };
};

export const requestFailure: requestFailure = (error: Error): Action => {
  return {
    type: REQUEST_FAILURE,
    error: error,
  };
};
