import { connect, Dispatch } from 'react-redux';
import {
    ProbeDetailInfo,
    StateProps as ProbeDetailStateProps,
    DispatchProps as ProbeDetailDispatchProps,
} from './components/ProbeDetailInfo';
import { push as routerPush } from 'react-router-redux';
import Probe from '@overflow/probe/api/model/Probe';


export function mapStateToProps(state: any, props: any): ProbeDetailStateProps {
    return {
        id: props.params.id,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): ProbeDetailDispatchProps {
    return {
      onDiscoveryClick: ( id: string) => {
        dispatch(routerPush( id + '/ targets' ));
      },
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(ProbeDetailInfo);
