import { connect, Dispatch } from 'react-redux';
import {
  SensorConfiguration,
  SensorConfigurationStateProps,
  SensorConfigurationDispatchProps,
} from './components/SensorConfiguration';
// import State from '../redux/state/ReadAllByTarget';

import Target from '@overflow/target/api/model/Target';
import Sensor from '@overflow/sensor/api/model/Sensor';
import MetaSensorItem from '@overflow/meta/api/model/MetaSensorItem';

import * as CrawlerReadAllByTargetActions from '@overflow/meta/redux/action/crawler_read_all_by_target';
import * as SensorItemReadAllActions from '@overflow/meta/redux/action/sensor_item_read_all';
import * as RegistActions from '../redux/action/regist';

// FIXME::....

export function mapStateToProps(state: any): SensorConfigurationStateProps {
  return {
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): SensorConfigurationDispatchProps {
  return {
    onCrawlerReadAllByTarget: (target: Target) => {
      dispatch(CrawlerReadAllByTargetActions.request(target));
    },
    onCheckCrawlerAuth: (authInfo: string) => {
      // dispatch(ReadActions.request(id));
    },
    // FIXME::how to sensor item?
    onReadMetaSensorItem: () => {
      dispatch(SensorItemReadAllActions.request());
    },
    onSaveSensor: (sensor: Sensor) => {
      dispatch(RegistActions.request(sensor));
    },
  };
}


export default connect(mapStateToProps, mapDispatchToProps)(SensorConfiguration);
