import { connect, Dispatch } from 'react-redux';
import {
    TargetDetail,
    StateProps as StateProps,
    DispatchProps as DispatchProps,
} from './components/TargetDetail';

import * as targetDetailActions from '../redux/action/read';

export function mapStateToProps(state: any): StateProps {
    return {
        probe: state.probe,
    };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
    return {
        onRead: (id: string) => {
            dispatch(targetDetailActions.request(id));
        }
    };
}

export default connect(mapStateToProps, mapDispatchToProps)(TargetDetail);
