import { connect, Dispatch } from 'react-redux';
import {
  TargetList,
  StateProps as StateProps,
  DispatchProps as DispatchProps,
} from './components/TargetList';

import Probe from '@overflow/probe/api/model/Probe';
import * as targetListActions from '../redux/action/read_all_by_probe';
import { push as routerPush } from 'react-router-redux';


export function mapStateToProps(state: any): StateProps {
  return {

  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DispatchProps {
  return {
    onReadAllByProbe: (probe: Probe) => {
      dispatch(targetListActions.request(probe));
    },
    onTargetSelection: (id: string) => {
      dispatch(routerPush('/target/' + id));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(TargetList);
