import * as _ from 'lodash';
import * as React from 'react';
import { Table } from 'semantic-ui-react';


export interface StateProps {
  jsonObj:any;
}

export interface DispatchProps {
  columnClick():void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  column: string;
  data: any;
  direction: string;
}


const tableData = [
  { 'name': 'John', 'age': 15, 'gender': 'Male' },
  { 'name': 'Amber', 'age': 40, 'gender': 'Female' },
  { 'name': 'Leslie', 'age': 25, 'gender': 'Female' },
  { 'name': 'Ben', 'age': 70, 'gender': 'Male' },
];

export class TableSort extends React.Component<Props, State> {
  constructor(props: any, context: any) {
    super(props, context);

    this.state = {
      column: null,
      data: tableData,
      direction: null,
    };
  }

  public render(): JSX.Element  {
    return (
      <Table sortable celled fixed>
        <Table.Header>
          {this.generationHeaderRow()}
        </Table.Header>
        <Table.Body>

        </Table.Body>
      </Table>
    );
  }

  private generationHeaderRow(): JSX.Element {
    return (
      <Table.Row>

      </Table.Row>
    );
  }

  private generationBodyRow(): JSX.Element {
    return (
      <Table.Row>

      </Table.Row>
    );
  }

  private handleSort(clickedColumn:any):void {
    const {column, data, direction} = this.state;

    if (column !== clickedColumn) {
      this.setState({
        column: clickedColumn,
        data: _.sortBy(data, [clickedColumn]),
        direction: 'ascending',
      });

      return;
    }

    this.setState({
      data: data.reverse(),
      direction: direction === 'ascending' ? 'descending' : 'ascending',
    });
  }

  private handleDirection():string {
    const { column, data, direction } = this.state;

    if (column === 'name') {
      return direction;
    } else if(column === 'age') {
      return direction;
    } else if (column === 'gender' ) {
      return direction;
    }

    return null;
  }
}

